unit spimain;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ExtCtrls, D2xxunit, DSSPI, ComCtrls, SPIDLLFuncUnit,
  FT2232HSPIUnit;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    ComboBox1: TComboBox;
    Panel2: TPanel;
    Memo1: TMemo;
    Panel3: TPanel;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Edit1: TEdit;
    Label1: TLabel;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Open1: TMenuItem;
    N1: TMenuItem;
    Label2: TLabel;
    UpDown1: TUpDown;
    Edit2: TEdit;
    Label3: TLabel;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Button4: TButton;
    FreqLabel: TLabel;
    ExternalDeviceLabel: TLabel;
    ExternalDeviceComboBox: TComboBox;
    DataValueEdit: TEdit;
    DataValueLabel: TLabel;
    DataTypeGroupBox: TGroupBox;
    ByteValueRadioButton: TRadioButton;
    WordValueRadioButton: TRadioButton;
    BufferSPICommandsCheckBox: TCheckBox;
    ExecuteCommandsButton: TButton;
    WriteWaitCheckBox: TCheckBox;
    OpenButton: TButton;
    CloseButton: TButton;
    MCP42XXXGroupBox: TGroupBox;
    Potentiometer0CheckBox: TCheckBox;
    Potentiometer1CheckBox: TCheckBox;
    PageWriteCheckBox: TCheckBox;
    BlockReadCheckBox: TCheckBox;
    GPIOHPanel: TPanel;
    GPIOHPinsLabel: TLabel;
    GPIOHBitLabel: TLabel;
    GPIOHBit1Label: TLabel;
    GPIOHBit1OutputCheckBox: TCheckBox;
    GPIOHBit1HighCheckBox: TCheckBox;
    GPIOHBit2Label: TLabel;
    GPIOHBit2OutputCheckBox: TCheckBox;
    GPIOHBit2HighCheckBox: TCheckBox;
    GPIOHBit3Label: TLabel;
    GPIOHBit3OutputCheckBox: TCheckBox;
    GPIOHBit3HighCheckBox: TCheckBox;
    GPIOHBit4Label: TLabel;
    GPIOHBit4OutputCheckBox: TCheckBox;
    GPIOHBit4HighCheckBox: TCheckBox;
    GPIOHBit5Label: TLabel;
    GPIOHBit5OutputCheckBox: TCheckBox;
    GPIOHBit5HighCheckBox: TCheckBox;
    GPIOHBit6Label: TLabel;
    GPIOHBit6OutputCheckBox: TCheckBox;
    GPIOHBit6HighCheckBox: TCheckBox;
    GPIOHBit7Label: TLabel;
    GPIOHBit7OutputCheckBox: TCheckBox;
    GPIOHBit7HighCheckBox: TCheckBox;
    GPIOHBit8Label: TLabel;
    GPIOHBit8OutputCheckBox: TCheckBox;
    GPIOHBit8HighCheckBox: TCheckBox;
    GPIOHValueReadEdit: TEdit;
    GPIOHValueReadLabel: TLabel;
    GPIOHUpdateHighButton: TButton;
    
    procedure ComboBox1DropDown(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Open1Click(Sender: TObject);
    procedure N1Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure UpDown1Changing(Sender: TObject; var AllowChange: Boolean);
    procedure FormCreate(Sender: TObject);
    procedure Edit2Exit(Sender: TObject);
    procedure Edit2Change(Sender: TObject);
    procedure ExternalDeviceComboBoxChange(Sender: TObject);
    procedure BufferSPICommandsCheckBoxClick(Sender: TObject);
    procedure OpenButtonClick(Sender: TObject);
    procedure CloseButtonClick(Sender: TObject);
    procedure ExecuteCommandsButtonClick(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ComboBox1Change(Sender: TObject);
    procedure GPIOHUpdateHighButtonClick(Sender: TObject);
        
  private
    { Private declarations }
  public
    { Public declarations }
end;

Type
  Names = Array[1..20] of string;
  Names_Ptr = ^Names;

var
  Form1: TForm1;
  My_Names : Names;

  BinFileName : TfileName;
  BinFile: file;
  ImageData : ARRAY[0..127] of word;

const
  FrequencyLabelDefaultText = 'Freq';

implementation

{$R *.DFM}

function Check_For_Dev_A_And_B(Name : string) : boolean;
var len,i : integer;
SubString : string;
begin
Check_For_Dev_A_And_B := false;
if (Name <> '') then
  begin
  len := length(Name);
  if (len > 2) then
    begin
    SubString := Name[len-1] + Name[len];
    if ((SubString = ' A') or (SubString = ' B')) then
      Check_For_Dev_A_And_B := true;
    end;
  end;
end;

procedure GetNames;
Var i : integer;
Has_A : boolean;
DeviceIndex: Dword;
DeviceNames: TStringList;
begin
  Form1.ComboBox1.Clear;

  if (FT2232HSPIDll = True) then
  begin
    DeviceNames := TStringList.Create;

    if GetSPIDeviceNames(DeviceNames) then
    begin
      if (DeviceNames.Count > 0) then
      begin
        for DeviceIndex := 0 to (DeviceNames.Count - 1) do
          Form1.ComboBox1.Items.Add(DeviceNames[DeviceIndex]);
      end;
    end;
  end
  else
  begin
    for i := 1 to 20 do My_Names[i] := '';
    List_Devs(@My_Names);
    i := 1;
    if (My_Names[i] <> '' ) then
    begin
      repeat
        Has_A := Check_For_Dev_A_And_B(My_Names[i]);
        if Has_A then Form1.ComboBox1.Items.Add(My_Names[i]);
        i := i + 1;
      until (My_Names[i] = '');
    end;
  end;
end;


procedure TForm1.ComboBox1DropDown(Sender: TObject);
begin
  GetNames;
end;


procedure Read_Data_From_Device(DName : String);
var passed : boolean;
i,j : integer;
DeviceName, ExternalDevice : string;
DisplayLines: TStringList;
begin
  form1.Memo1.Clear;
  form1.Memo1.Update;
  
  if (FT2232HSPIDll = True) then
  begin
    DeviceName := Trim(form1.ComboBox1.Text);
    ExternalDevice := Trim(form1.ExternalDeviceComboBox.Text);

    if ((DeviceName <> '') and (ExternalDevice <> '')) then
    begin
      DisplayLines := TStringList.Create;

      Read_External_Device(DeviceName, form1.ExternalDeviceComboBox.ItemIndex, strtoint(Trim(form1.Edit2.Text)),
                           form1.BlockReadCheckBox.Checked, form1.BufferSPICommandsCheckBox.Checked, DisplayLines);

      for i := 0 to (DisplayLines.Count - 1) do
        form1.Memo1.Lines.Add(DisplayLines[i]);                           

      DisplayLines.Free;
    end
    else
    begin
      if (DeviceName = '') then
        form1.Memo1.Lines.Add('No valid device selected in drop down window.')
      else
        form1.Memo1.Lines.Add('No valid external device selected in drop down window.')
    end;
  end
  else
  begin
    passed := Init_Controller(DName);
    if passed then
    begin
      for j := 0 to $7F do
      begin
        i := Read_Location(j);
        i := i AND $FFFF;
        imageData[j] := i;
        form1.Memo1.Lines.Add('Addr : ' + HexWrdToStr(j)+' Data : ' + HexWrdToStr(i) );
      end;
      ClosePort;
    end;
  end;
end;

function  Program_Device(bErase: Boolean): Boolean;
var
  DeviceName, ExternalDevice : string;
  DisplayLines: TStringList;
  i: Integer;
begin
  if (FT2232HSPIDll = True) then
  begin
    DeviceName := Trim(form1.ComboBox1.Text);
    ExternalDevice := Trim(form1.ExternalDeviceComboBox.Text);

    if ((DeviceName <> '') and (ExternalDevice <> '')) then
    begin
      if (not form1.BufferSPICommandsCheckBox.Checked) then
      begin
        form1.Memo1.Clear;
        form1.Memo1.Update;
      end;
    
      DisplayLines := TStringList.Create;

      Program_External_Device(DeviceName, form1.ExternalDeviceComboBox.ItemIndex,
                              strtoint(Trim(form1.Edit2.Text)), bErase,
                              Form1.WriteWaitCheckBox.Checked, Form1.PageWriteCheckBox.Checked,
                              Trim(Form1.DataValueEdit.Text),
                              Form1.Potentiometer0CheckBox.Checked, Form1.Potentiometer1CheckBox.Checked, 
                              Form1.BufferSPICommandsCheckBox.checked, DisplayLines);

      for i := 0 to (DisplayLines.Count - 1) do
        form1.Memo1.Lines.Add(DisplayLines[i]);

      DisplayLines.Free;
    end
    else
    begin
      if (DeviceName = '') then
        form1.Memo1.Lines.Add('No valid device selected in drop down window.')
      else
        form1.Memo1.Lines.Add('No valid external device selected in drop down window.')
    end;
  end;

  Result := True
end;

procedure Program_To_Address;
var passed : boolean;
i,j : integer;
DName : string;
begin
  if (FT2232HSPIDll = True) then
    Program_Device(False)
  else
  begin
    form1.Memo1.Clear;
    form1.Memo1.Update;

    DName := form1.ComboBox1.Text;
    passed := Check_For_Dev_A_And_B(DName);
    if passed then
    begin
      passed := Init_Controller(DName);
      if passed then
      begin
        for j := 0 to $7F do
        begin
          passed := Write_Location(j,j);
          form1.Memo1.Lines.Add('Addr : ' + HexWrdToStr(j)+' Data : ' + HexWrdToStr(j) );
        end;
        ClosePort;
      end;
    end
    else
    begin
      form1.Memo1.Lines.Add('You must select the "A" or "B" port of the chip to use the MPSSE');
    end;
  end;
end;

procedure Prog_From_File;
var passed : boolean;
i,j : integer;
DName : string;
begin
DName := form1.ComboBox1.Text;
passed := Check_For_Dev_A_And_B(DName);
if passed then
  begin
  passed := Init_Controller(DName);
  if passed then
    begin
    for j := 0 to $7F do
      begin
      passed := Write_Location(j,imageData[j]);
      form1.Memo1.Lines.Add('Addr : ' + HexWrdToStr(j)+' Data : ' + HexWrdToStr(j) );
      end;
    ClosePort;
    end;
  end
else
  begin
  form1.Memo1.Lines.Add('You must select the "A" or "B" port of the chip to use the MPSSE');
  end;
end;

procedure TForm1.Button1Click(Sender: TObject);
var passed : boolean;
DName,tst : string;
begin
dsspi.speed := strtoint(form1.Edit2.Text);
DName := form1.ComboBox1.Text;
passed := Check_For_Dev_A_And_B(DName);
if passed then
  begin
  Read_Data_From_Device(DName);
  end
else
  begin
  form1.Memo1.Lines.Add('You must select the "A" or "B" port of the chip to use the MPSSE');
  end;
end;

procedure update_clk_divisor;
begin
form1.Edit2.Text := inttostr(form1.UpDown1.Position);
dsspi.speed := strtoint(form1.Edit2.Text);
end;

procedure TForm1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
  update_clk_divisor;
end;

procedure TForm1.Button3Click(Sender: TObject);
var passed : boolean;
DName : string;
begin
  dsspi.speed := strtoint(form1.Edit2.Text);
  DName := form1.ComboBox1.Text;
  passed := Check_For_Dev_A_And_B(DName);
  if passed then
  begin
    if (FT2232HSPIDll = True) then
      Program_Device(True)
    else
    begin
      passed := Erase_93C56(DName);
      if passed then
        form1.Memo1.Lines.Add('Erase - Success')
      else
        form1.Memo1.Lines.Add('Erase - Failed');
    end;
  end
  else
    form1.Memo1.Lines.Add('You must select the "A" or "B" port of the chip to use the MPSSE');
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
Program_To_Address;
end;

procedure Read_In_Array;
var cnt : integer;
ByteData : ARRAY[0..255] of byte;
begin
Form1.OpenDialog1.FileName := '';
Form1.OpenDialog1.execute;
if Form1.OpenDialog1.FileName <> '' then
  begin
    form1.Edit1.Text := Form1.OpenDialog1.FileName;
    try
    BinFileName := Form1.OpenDialog1.FileName;
    AssignFile(BinFile,BinFileName);
    reset(BinFile,1);
    blockread(BinFile,ByteData,256,Cnt);
    CloseFile(BinFile);
    finally
    end;
  for cnt := 0 to 127 do
    ImageData[cnt] := (ByteData[(Cnt * 2) + 1] * 256 ) OR (ByteData[Cnt * 2]);
  end;
end;

procedure TForm1.Open1Click(Sender: TObject);
begin
Read_In_Array;
end;

procedure TForm1.N1Click(Sender: TObject);
var Cnt : integer;
ByteData : ARRAY[0..255] of byte;
begin
for cnt := 0 to 127 do
  begin
  ByteData[(Cnt * 2)] := ImageData[cnt] AND $FF;
  ByteData[(Cnt * 2) + 1] := ImageData[cnt] DIV 256;
  end;
Form1.SaveDialog1.FileName := '';
Form1.SaveDialog1.Execute;
if Form1.SaveDialog1.FileName <> '' then
  begin
    form1.Edit1.Text := Form1.SaveDialog1.FileName;
    try
    BinFileName := Form1.SaveDialog1.FileName;
    AssignFile(BinFile,BinFileName);
    rewrite(BinFile,1);
    blockwrite(BinFile,ByteData,256,Cnt);
    CloseFile(BinFile);
    finally
    end;
  end;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
Read_In_Array;
Prog_From_File;
end;

procedure TForm1.UpDown1Changing(Sender: TObject;
  var AllowChange: Boolean);
begin
//update_clk_divisor;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
  dwDeviceHandleIndex: Dword;
  SPIChipIndex: Dword;
begin
  FT2232HSPIDll := True;
  FT2232HSPI := TFT2232HSPI.Create;
  //ExecuteButton.Enabled := False;

  for dwDeviceHandleIndex := 0 to 49 do
  begin
    HiSpeedDevices[dwDeviceHandleIndex].ftHandle := 0;
    HiSpeedDevices[dwDeviceHandleIndex].DeviceName := '';
    DeviceBitLengths[dwDeviceHandleIndex].iNumBitLengths := 0;
  end;

  dwNumOpenedDevices := 0;

  form1.UpDown1.Position := MaxFreq93LC56BClockDivisor;
  update_clk_divisor;

  Form1.ExternalDeviceComboBox.Clear;
  for SPIChipIndex := 0 to (NumSPIChips - 1) do
    Form1.ExternalDeviceComboBox.Items.Add(SPIChips[SPIChipIndex]);

  BufferSPICommandsCheckBox.Checked := False;
  ExecuteCommandsButton.Enabled := False;

  ByteValueRadioButton.Enabled := False;
  ByteValueRadioButton.Checked := True;
  WordValueRadioButton.Enabled := False;

  Potentiometer0CheckBox.Enabled := False;
  Potentiometer0CheckBox.Checked := False;
  Potentiometer1CheckBox.Enabled := False;
  Potentiometer1CheckBox.Checked := False;

  WriteWaitCheckBox.Checked := True;

  DataValueEdit.Text := '';
end;

procedure TForm1.GPIOHUpdateHighButtonClick(Sender: TObject);
var
  passed : boolean;
  DName : string;
  ExternalDeviceIndex: Integer;
  ftStatus: FTC_STATUS;
  ChipSelectsDisableStates: FtcChipSelectPins;
  HighInputOutputPins: FthInputOutputPins;
  HighPinsInputData: FthLowHighPins;
  HighPinsReadValue: Integer;
begin
  DName := form1.ComboBox1.Text;
  passed := Check_For_Dev_A_And_B(DName);
  if passed then
  begin
    GPIOHValueReadEdit.Text := '';

    ExternalDeviceIndex := form1.ExternalDeviceComboBox.ItemIndex;

    if (ExternalDeviceIndex = SPI93LC56BChipIndex) then
    begin
      ChipSelectsDisableStates.bADBUS3ChipSelectPinState := False;
      ChipSelectsDisableStates.bADBUS4GPIOL1PinState := False;
      ChipSelectsDisableStates.bADBUS5GPIOL2PinState := False;
      ChipSelectsDisableStates.bADBUS6GPIOL3PinState := False;
      ChipSelectsDisableStates.bADBUS7GPIOL4PinState := False; // not used
    end;

    HighInputOutputPins.bPin1InputOutputState := GPIOHBit1OutputCheckBox.Checked;
    HighInputOutputPins.bPin1LowHighState := GPIOHBit1HighCheckBox.Checked;
    HighInputOutputPins.bPin2InputOutputState := GPIOHBit2OutputCheckBox.Checked;
    HighInputOutputPins.bPin2LowHighState := GPIOHBit2HighCheckBox.Checked;
    HighInputOutputPins.bPin3InputOutputState := GPIOHBit3OutputCheckBox.Checked;
    HighInputOutputPins.bPin3LowHighState := GPIOHBit3HighCheckBox.Checked;
    HighInputOutputPins.bPin4InputOutputState := GPIOHBit4OutputCheckBox.Checked;
    HighInputOutputPins.bPin4LowHighState := GPIOHBit4HighCheckBox.Checked;
    HighInputOutputPins.bPin5InputOutputState := GPIOHBit5OutputCheckBox.Checked;
    HighInputOutputPins.bPin5LowHighState := GPIOHBit5HighCheckBox.Checked;
    HighInputOutputPins.bPin6InputOutputState := GPIOHBit6OutputCheckBox.Checked;
    HighInputOutputPins.bPin6LowHighState := GPIOHBit6HighCheckBox.Checked;
    HighInputOutputPins.bPin7InputOutputState := GPIOHBit7OutputCheckBox.Checked;
    HighInputOutputPins.bPin7LowHighState := GPIOHBit7HighCheckBox.Checked;
    HighInputOutputPins.bPin8InputOutputState := GPIOHBit8OutputCheckBox.Checked;
    HighInputOutputPins.bPin8LowHighState := GPIOHBit8HighCheckBox.Checked;

    ftStatus := FT2232HSPI.SetHiSpeedDeviceGPIOs(ftHandle, @ChipSelectsDisableStates, @HighInputOutputPins);

    if (ftStatus = FTC_SUCCESS) then
    begin
      ftStatus := FT2232HSPI.GetHiSpeedDeviceGPIOs(ftHandle, @HighPinsInputData);

      if (ftStatus = FTC_SUCCESS) then
      begin
        HighPinsReadValue := 0;

        if (HighPinsInputData.bPin1LowHighState = True) then
        begin
          HighPinsReadValue := 1;
        end;
        if (HighPinsInputData.bPin2LowHighState = True) then
        begin
          HighPinsReadValue := HighPinsReadValue + 2;
        end;
        if (HighPinsInputData.bPin3LowHighState = True) then
        begin
          HighPinsReadValue := HighPinsReadValue + 4;
        end;
        if (HighPinsInputData.bPin4LowHighState = True) then
        begin
          HighPinsReadValue := HighPinsReadValue + 8;
        end;
        if (HighPinsInputData.bPin5LowHighState = True) then
        begin
          HighPinsReadValue := HighPinsReadValue + 16;
        end;
        if (HighPinsInputData.bPin6LowHighState = True) then
        begin
          HighPinsReadValue := HighPinsReadValue + 32;
        end;
        if (HighPinsInputData.bPin7LowHighState = True) then
        begin
          HighPinsReadValue := HighPinsReadValue + 64;
        end;
        if (HighPinsInputData.bPin8LowHighState = True) then
        begin
          HighPinsReadValue := HighPinsReadValue + 128;
        end;

        GPIOHValueReadEdit.Text := intToStr(HighPinsReadValue);
      end
      else
        DisplayFT2232HSPIDllError('GPIOHUpdateHighButtonClick', 'GetHiSpeedDeviceGPIOs', ftStatus);
    end
    else
      DisplayFT2232HSPIDllError('GPIOHUpdateHighButtonClick', 'SetHiSpeedDeviceGPIOs', ftStatus);
  end
  else
    form1.Memo1.Lines.Add('You must select the "A" or "B" port of the chip to use the MPSSE');
end;

procedure TForm1.Edit2Exit(Sender: TObject);
begin
if (form1.Edit2.Text <> '') then
  begin
  form1.UpDown1.Position := strtoint(form1.edit2.Text );
  update_clk_divisor;
  end;
end;

procedure TForm1.Edit2Change(Sender: TObject);
var
  ftStatus: FTC_STATUS;
  ClockDivisor, ClockFrequencyHz: Dword;
begin
  if (form1.Edit2.Text <> '') then
  begin
    update_clk_divisor;

    if (FT2232HSPIDll = True) then
    begin
      ClockDivisor := strtoint(Trim(form1.Edit2.Text));
      ftStatus := FT2232HSPI.GetClock(ClockDivisor, @ClockFrequencyHz);

      if (ftStatus = FTC_SUCCESS) then
        Form1.FreqLabel.Caption := FrequencyLabelDefaultText + '(' + IntToStr(ClockFrequencyHz) + 'Hz)'
      else
        DisplayFT2232HSPIDllError('Edit2Change', 'GetClock', ftStatus);
    end;
  end;
end;


procedure TForm1.ExternalDeviceComboBoxChange(Sender: TObject);
begin
  case form1.ExternalDeviceComboBox.ItemIndex of
    SPI93LC56BChipIndex:
    begin
      WordValueRadioButton.Checked := True;
      form1.UpDown1.Position := MaxFreq93LC56BClockDivisor;
      WriteWaitCheckBox.Enabled := True;
      WriteWaitCheckBox.Checked := True;
      DataValueEdit.Text := '';
      Potentiometer0CheckBox.Enabled := False;
      Potentiometer0CheckBox.Checked := False;
      Potentiometer1CheckBox.Enabled := False;
      Potentiometer1CheckBox.Checked := False;
      PageWriteCheckBox.Enabled := False;
      PageWriteCheckBox.Checked := False;
    end;
    SPIMCP42XXXChipIndex:
    begin
      ByteValueRadioButton.Checked := True;
      form1.UpDown1.Position := MaxFreqMCP42XXXClockDivisor;
      WriteWaitCheckBox.Enabled := False;
      WriteWaitCheckBox.Checked := False;
      DataValueEdit.Text := '80';
      Potentiometer0CheckBox.Enabled := True;
      Potentiometer0CheckBox.Checked := True;
      Potentiometer1CheckBox.Enabled := True;
      Potentiometer1CheckBox.Checked := True;
      PageWriteCheckBox.Enabled := False;
      PageWriteCheckBox.Checked := False;
    end;
    SPIDS1305ChipIndex:
    begin
      form1.UpDown1.Position := MaxFreqDS1305ClockDivisor;
      DataValueEdit.Text := '';
      Potentiometer0CheckBox.Enabled := False;
      Potentiometer0CheckBox.Checked := False;
      Potentiometer1CheckBox.Enabled := False;
      Potentiometer1CheckBox.Checked := False;
      PageWriteCheckBox.Enabled := False;
      PageWriteCheckBox.Checked := False;
    end;
    SPIM95128ChipIndex:
    begin
      form1.UpDown1.Position := MaxFreqM95128ClockDivisor;
      DataValueEdit.Text := '';
      ByteValueRadioButton.Checked := True;
      WriteWaitCheckBox.Enabled := False;
      WriteWaitCheckBox.Checked := False;
      Potentiometer0CheckBox.Enabled := False;
      Potentiometer0CheckBox.Checked := False;
      Potentiometer1CheckBox.Enabled := False;
      Potentiometer1CheckBox.Checked := False;
      PageWriteCheckBox.Enabled := True;
      PageWriteCheckBox.Checked := False;
    end;
    SPIM95020ChipIndex:
    begin
      form1.UpDown1.Position := MaxFreqM95020ClockDivisor;
      DataValueEdit.Text := '';
      ByteValueRadioButton.Checked := True;
      WriteWaitCheckBox.Enabled := False;
      WriteWaitCheckBox.Checked := False;
      Potentiometer0CheckBox.Enabled := False;
      Potentiometer0CheckBox.Checked := False;
      Potentiometer1CheckBox.Enabled := False;
      Potentiometer1CheckBox.Checked := False;
      PageWriteCheckBox.Enabled := True;
      PageWriteCheckBox.Checked := False;
    end;
  end;

  update_clk_divisor;
end;

procedure TForm1.BufferSPICommandsCheckBoxClick(Sender: TObject);
var
  DeviceHandleIndex: Dword;
  ftStatus: FTC_STATUS;
  DeviceName, ExternalDevice : string;
  dwLocationID: Dword;
  dwClockDivisor: Dword;
  dwDeviceHandleIndex, dwDeviceIndex: Dword;
begin
  ExecuteCommandsButton.Enabled := False;

  if (FT2232HSPIDll = True) then
  begin
    if BufferSPICommandsCheckBox.Checked then
    begin
      DeviceName := Trim(form1.ComboBox1.Text);
      ExternalDevice := Trim(form1.ExternalDeviceComboBox.Text);

      if ((DeviceName <> '') and (ExternalDevice <> '')) then
      begin
        ftHandle := 0;
        for dwDeviceHandleIndex := 0 to 49 do
        begin
          if ((HiSpeedDevices[dwDeviceHandleIndex].DeviceName = DeviceName) and (ftHandle = 0)) then
          begin
            ftHandle := HiSpeedDevices[dwDeviceHandleIndex].ftHandle;

            dwDeviceIndex := dwDeviceHandleIndex;
          end;
        end;

        if (ftHandle <> 0) then
        begin
          DeviceBitLengths[dwDeviceIndex].iNumBitLengths := 0;

          ftStatus := FT2232HSPI.ClearDeviceCmdSequence(fthandle);

          if (ftStatus = FTC_SUCCESS) then
            ExecuteCommandsButton.Enabled := True
          else
            DisplayFT2232HSPIDllError('BufferSPICommandsCheckBoxClick', 'ClearDeviceCmdSequence', ftStatus);
        end;
      end
      else
      begin
        if (DeviceName = '') then
          form1.Memo1.Lines.Add('No valid device selected in drop down window.')
        else
          form1.Memo1.Lines.Add('No valid external device selected in drop down window.')
      end;
    end;      
  end;

  form1.Memo1.Clear;
  form1.Memo1.Update;
end;

procedure TForm1.OpenButtonClick(Sender: TObject);
var
  ftStatus: FTC_STATUS;
  DeviceName, ExternalDevice : string;
  dwLocationID, dwClockFrequencyHz: Dword;
  dwClockDivisor: Dword;
  dwDeviceHandleIndex: Dword;
  OpenedDeviceName: String;
begin
  if (FT2232HSPIDll = True) then
  begin
    DeviceName := Trim(form1.ComboBox1.Text);
    ExternalDevice := Trim(form1.ExternalDeviceComboBox.Text);

    if ((DeviceName <> '') and (ExternalDevice <> '')) then
    begin
      dwClockDivisor := strtoint(Trim(form1.Edit2.Text));

      if OpenSPIDevice(DeviceName, dwClockDivisor, @dwClockFrequencyHz) then
        form1.Memo1.Lines.Add('Successfully opened ' + DeviceName + ' device');
    end
    else
    begin
      if (DeviceName = '') then
        form1.Memo1.Lines.Add('No valid device selected in drop down window.')
      else
        form1.Memo1.Lines.Add('No valid external device selected in drop down window.')
    end;
  end;
end;

procedure TForm1.CloseButtonClick(Sender: TObject);
var
  DeviceName, ExternalDevice : string;
  DisplayLines: TStringList;
begin
  if (FT2232HSPIDll = True) then
  begin
    DeviceName := Trim(form1.ComboBox1.Text);
    ExternalDevice := Trim(form1.ExternalDeviceComboBox.Text);

    if ((DeviceName <> '') and (ExternalDevice <> '')) then
    begin
      DisplayLines := TStringList.Create;

      if  CloseSPIDevice(DeviceName, DisplayLines) then
        form1.Memo1.Lines.Add('Successfully closed ' + DeviceName + ' device')
      else
        form1.Memo1.Lines.Add(DisplayLines[0]);
    end
    else
    begin
      if (DeviceName = '') then
        form1.Memo1.Lines.Add('No valid device selected in drop down window.')
      else
        form1.Memo1.Lines.Add('No valid external device selected in drop down window.')
    end;        
  end;
end;

procedure TForm1.ExecuteCommandsButtonClick(Sender: TObject);
var
  DeviceName, ExternalDevice : string;
  DisplayLines: TStringList;
  i: Integer;
begin
  form1.Memo1.Clear;
  form1.Memo1.Update;
  
  if (FT2232HSPIDll = True) then
  begin
    if BufferSPICommandsCheckBox.Checked then
    begin
      DeviceName := Trim(form1.ComboBox1.Text);
      ExternalDevice := Trim(form1.ExternalDeviceComboBox.Text);

      if ((DeviceName <> '') and (ExternalDevice <> '')) then
      begin
        DisplayLines := TStringList.Create;

        ExecuteSPIDeviceCommandSequence(DeviceName, form1.ExternalDeviceComboBox.ItemIndex, DisplayLines);

        if (DisplayLines.Count > 0) then
        begin
          for i := 0 to (DisplayLines.Count - 1) do
            form1.Memo1.Lines.Add(DisplayLines[i]);
        end;

        DisplayLines.Free;
      end
      else
      begin
        if (DeviceName = '') then
          form1.Memo1.Lines.Add('No valid device selected in drop down window.')
        else
          form1.Memo1.Lines.Add('No valid external device selected in drop down window.')
      end;
    end;
  end;
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
var
  dwDeviceHandleIndex, dwDeviceIndex: Dword;
begin
  for dwDeviceHandleIndex := 0 to 49 do
  begin
    if (HiSpeedDevices[dwDeviceHandleIndex].fthandle <> 0) then
    begin
      FT2232HSPI.Close(HiSpeedDevices[dwDeviceHandleIndex].fthandle);

      HiSpeedDevices[dwDeviceHandleIndex].ftHandle := 0;
      HiSpeedDevices[dwDeviceHandleIndex].DeviceName := '';

      if (dwNumOpenedDevices > 0) then
        Dec(dwNumOpenedDevices);
    end;
  end;
end;

procedure TForm1.ComboBox1Change(Sender: TObject);
var
  DeviceHandleIndex: Dword;
  DeviceName: String;
begin
  ftHandle := 0;
  
  DeviceName := Form1.ComboBox1.Items.Strings[Form1.ComboBox1.ItemIndex];

  for DeviceHandleIndex := 0 to 49 do
  begin
    if (HiSpeedDevices[DeviceHandleIndex].DeviceName = DeviceName) then
      ftHandle := HiSpeedDevices[DeviceHandleIndex].ftHandle;
  end;

  //form1.ExternalDeviceComboBox.ItemIndex := 0;
end;

end.
